' 

' -------------------
' build with PBWIN 10
' -------------------

#IF 0  ' 

----------------------------------------
UNICODE zero terminated string functions
----------------------------------------

NOTE : The functions that change the string MODIFY
       the original string passed to it.

uc_len          return the character count of a unicode string
uc_left         truncates a string to a given character count
uc_right        truncates a string from the right side
uc_reverse      reverse a unicode string
uc_ltrim        left trim tabs and spaces from a unicode string
uc_rtrim        right trim tabs and spaces from a unicode string
uc_trim         left and right trim unicode string
uc_cmp          compare two unicode strings
uc_cat          join one string to the end of another
uc_multicat     join multiple strings to the end of a string
uc_find         find a unicode sub-string in a main string
uc_append       loop append unicode string function

#ENDIF ' 

  ' --------------------------
  ' macro for append operation
  ' --------------------------
    MACRO wc_append(cloc,pbuffer,text)
      ! push text
      ! push pbuffer
      ! push cloc
      ! call uc_append
    END MACRO

  ' -------------------------------------
  ' renamed to avoid include file clashes
  ' -------------------------------------
    DECLARE FUNCTION Global_Alloc LIB "KERNEL32.DLL" ALIAS "GlobalAlloc" _
                                (BYVAL wFlags AS DWORD, BYVAL dwBytes AS DWORD) AS DWORD
    DECLARE FUNCTION Global_Free LIB "KERNEL32.DLL" ALIAS "GlobalFree" _
                                (BYVAL hMem AS DWORD) AS DWORD

    MACRO GMEM_FIXED          = &H0
    MACRO GMEM_MOVEABLE       = &H2
    MACRO GMEM_NOCOMPACT      = &H10
    MACRO GMEM_NODISCARD      = &H20
    MACRO GMEM_ZEROINIT       = &H40

    DECLARE FUNCTION uc_msgbox LIB "USER32.DLL" ALIAS "MessageBoxW" _
                    (ByVal hWnd AS DWORD, ByVal lpText AS DWORD, _
                     lpCaption AS WSTRINGZ,ByVal dwType AS DWORD) AS LONG
  ' ------------------------------------------------
  ' macro to display a unicode string by its address
  ' ------------------------------------------------
    MACRO ResultBox(pUnicode,quoted)
      uc_msgbox 0,pUnicode,quoted,%MB_OK
    END MACRO

' 

FUNCTION PBmain as LONG

    LOCAL rval as DWORD
    LOCAL wszStr as WSTRINGZ * 64

    wszStr = "1234567890"
    ! lea eax, wszStr
    ! push eax
    ! call uc_len
    ! mov rval, eax

    msgbox format$(rval)

  ' ******************************

    wszStr = "1234567890"
    ! push 6
    ! lea eax, wszStr
    ! push eax
    ! call uc_left

    msgbox wszStr

  ' ******************************

    wszStr = "1234567890"
    ! push 6
    ! lea eax, wszStr
    ! push eax
    ! call uc_right

    msgbox wszStr

  ' ******************************

    wszStr = "1234567890"
    ! lea eax, wszStr
    ! push eax
    ! call uc_reverse

    msgbox wszStr

  ' ******************************

    wszStr = "	 	 	 	 1234567890"
    ! lea eax, wszStr
    ! push eax
    ! call uc_ltrim

    msgbox wszStr

  ' ******************************

    wszStr = "1234567890	 	 	 	 "
    ! lea eax, wszStr
    ! push eax
    ! call uc_rtrim

    msgbox wszStr

  ' ******************************

    wszStr = "	 	1234567890 	 	 "
    ! lea eax, wszStr
    ! push eax
    ! call uc_trim

    msgbox wszStr

  ' ******************************

    LOCAL txt1 as WSTRINGZ * 32
    LOCAL txt2 as WSTRINGZ * 32
    LOCAL txt3 as WSTRINGZ * 32
    LOCAL trv  as DWORD

    txt1 = "text one"
    txt2 = "text two"

    ! lea eax, txt2
    ! push eax
    ! lea eax, txt1
    ! push eax
    ! call uc_cmp
    ! mov trv, eax

    msgbox format$(trv)

  ' ******************************

    ! lea eax, txt1
    ! push eax
    ! lea eax, txt1
    ! push eax
    ! call uc_cmp
    ! mov trv, eax

    msgbox format$(trv)

  ' ******************************

    wszStr = "Original String"
    txt1 = " Next String "
    txt2 = " Last String"

    ! lea eax, txt1
    ! push eax
    ! lea eax, wszStr
    ! push eax
    ! call uc_cat

    msgbox wszStr

  ' ******************************

    ! lea eax, txt2
    ! push eax
    ! lea eax, wszStr
    ! push eax
    ! call uc_cat

    msgbox wszStr

    LOCAL esp_ as DWORD

    wszStr = ""

  ' ******************************

    txt1 = "Original String"
    txt2 = " Next String"
    txt3 = " Last String"

    ! lea eax, txt3
    ! push eax
    ! lea eax, txt2
    ! push eax
    ! lea eax, txt1
    ! push eax
    ! lea eax, wszStr
    ! push eax
    ! push 3
    ! call uc_multicat
    ! add esp, 20           ; <<<<    balance the stack here

    msgbox wszStr

  ' ******************************

    wszStr = "This is a text of the uc_find algorithm"
    txt1   = "of the"

    ! lea eax, txt1
    ! push eax
    ! lea eax, wszStr
    ! push eax
    ! push 0
    ! call uc_find
    ! mov trv, eax

    msgbox format$(trv)

  ' ******************************

    LOCAL cloc  as DWORD
    LOCAL pstr  as DWORD
    LOCAL cntr  as DWORD
    LOCAL szptr as WSTRINGZ PTR
    LOCAL wtxt1 as WSTRINGZ * 128

    szptr = Global_Alloc(GMEM_FIXED or GMEM_ZEROINIT,1024*1024*2)  ' 1 million wide characters

    wtxt1 = "This is a test of GlobalAlloc() memory being used for WIDE string operations"+chr$(13,10)
    pstr = VarPtr(wtxt1)

    cloc = 0
    cntr = 0

    Do
      wc_append(cloc,szptr,pstr)            ' append a string from its address
      ! mov cloc, eax
      ! add cntr, 1
    Loop while cntr < 25

    ResultBox(szptr,"Result")

    Global_Free szptr


End FUNCTION

' 

FASTPROC uc_append

    PREFIX "! "

    mov eax, [esp+8]            ; load the buffer address
    add eax, [esp+4]            ; add the "cloc" offset
    mov ecx, [esp+12]           ; the string address

    push ebx

    mov ebx, -2
  lbl0:
    add ebx, 2
    movzx edx, WORD PTR [ecx+ebx]   ; copy chars to "cloc"
    mov [eax+ebx], dx
    test edx, edx               ; exit on written zero
    jnz lbl0

    mov eax, [esp+4][4]         ; calculate the next "cloc"
    add eax, ebx                ; return it in EAX

    pop ebx

    ret 12

    END PREFIX

END FASTPROC

' 

FASTPROC uc_len

    PREFIX "! "

    mov eax, [esp+4]            ; load the string address
    sub eax, 2                  ; set up the address for loop entry
  lbl0:
    add eax, 2                  ; increment up to the next WORD sized character
    cmp WORD PTR [eax], 0       ; test if UNICODE character is terminator
    jne lbl0                    ; loop back if not

    sub eax, [esp+4]            ; sub the start address from EAX
    shr eax, 1                  ; half the result for UNICODE length
    ret 4                       ; return while balancing the stack

    END PREFIX

END FASTPROC

' 

FASTPROC uc_left

    PREFIX "! "

    mov eax, [esp+4]            ; string address
    mov ecx, [esp+8]            ; char count
    sub eax, 2                  ; set up the address for loop entry

  lbl0:
    add eax, 2
    cmp WORD PTR [eax], 0       ; exit if zero is found before required length
    je lblout
    sub ecx, 1
    jns lbl0

    mov WORD PTR [eax], 0       ; else truncate the string

  lblout:
    ret 8

    END PREFIX

END FASTPROC

' 

FASTPROC uc_right

    PREFIX "! "

    mov eax, [esp+4]            ; load address into EAX
    push eax                    ; push it onto the stack
    call uc_len                 ; get the string length

    cmp eax, [esp+8]            ; compare it against required length
    ja lbl0                     ; if its greater that required, proceed.
    ret 8                       ; else exit with no change

  lbl0:
    sub eax, [esp+8]            ; calculate the OFFSET for the 1st required character
    add eax, eax                ; double it for 2 byte UNICODE character

    mov ecx, [esp+4]            ; load the string address in both source and destination registers
    mov edx, [esp+4]
    add ecx, eax                ; add the 1st character OFFSET to the source register

  lbl1:
    movzx eax, WORD PTR [ecx]   ; load each UNICODE character into EBX
    mov WORD PTR [edx], ax      ; copy it to the destination register
    add ecx, 2                  ; add 2 for next UNICODE character location
    add edx, 2
    test eax, eax               ; test if last written character is zero.
    jnz lbl1                    ; loop back if not

    ret 8                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_reverse

    PREFIX "! "

    push ebx
    push esi

    mov eax, [esp+12]           ; load src address into EAX ([esp+4] plus 8 {2 pushes})
    push eax
    call uc_len

    mov esi, eax                ; write char count to ESI
    shr esi, 1                  ; int divide it by 2

    add eax, eax                ; double UNICODE length to get offset of end

    mov ecx, [esp+12]
    mov edx, [esp+12]
    add edx, eax                ; add the OFFSET to get end character
    sub edx, 2

  ; read 1st and last chars then swap them then read
  ; next inner pair until middle of string is reached

  lbl0:
    movzx eax, WORD PTR [ecx]
    movzx ebx, WORD PTR [edx]
    mov [ecx], bx
    mov [edx], ax
    add ecx, 2
    sub edx, 2
    sub esi, 1
    jnz lbl0

    pop esi
    pop ebx

    ret 4                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_ltrim

    PREFIX "! "

    mov eax, [esp+4]            ; load the stack variable into EAX
    mov ecx, [esp+4]            ; load the stack variable into ECX
    sub eax, 2

  lbl0:
    add eax, 2
    cmp WORD PTR [eax], 32      ; strip space
    je lbl0
    cmp WORD PTR [eax], 9       ; strip tab
    je lbl0

  ; ------------------------------------------
  ; copy the rest back to string start address
  ; ------------------------------------------
  lbl1:
    movzx edx, WORD PTR [eax]   ; zero extend WORD into EDX
    mov WORD PTR [ecx], dx      ; write it back to same buffer
    add eax, 2
    add ecx, 2
    test edx, edx               ; test for zero after it is written
    jnz lbl1                    ; loop back if not zero

    ret 4                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_rtrim

    PREFIX "! "

    mov ecx, [esp+4]            ; load string address in ECX
    xor edx, edx                ; zero EDX
    sub ecx, 2

  lbl0:
    add ecx, 2
    cmp WORD PTR [ecx], 0       ; exit loop on zero
    je lbl2
    cmp WORD PTR [ecx], 32      ; loop back on space
    je lbl0
    cmp WORD PTR [ecx], 9       ; loop back on tab
    je lbl0
  lbl1:
    mov edx, ecx                ; else write last char address to EDX
    jmp lbl0

  lbl2:
    test edx, edx               ; test if EDX has been modified
    jz lbl3
    mov WORD PTR [edx+2], 0     ; if it has, write terminator 1 char after
  lbl3:                         ' last non space/tab char
    ret 4                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_trim

    PREFIX "! "

    mov eax, [esp+4]
    push eax
    call uc_ltrim

    mov eax, [esp+4]
    push eax
    call uc_rtrim

    ret 4                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_cmp

    PREFIX "! "

    push edi

    mov edx, [esp+8]
    mov edi, [esp+12]
    mov eax, -2
    xor ecx, ecx

  lbl0:
    add eax, 2
    movzx ecx, WORD PTR [edx+eax]   ; load each char
    cmp cx, [edi+eax]               ; compare it to char in other string
    jne mismatch
    test ecx, ecx
    jnz lbl0

    shr eax, 1                  ; half for character count on match
    jmp match

  mismatch:
    xor eax, eax                ; zero for mismatch

  match:
    pop edi

    ret 8                       ; balance the stack and return

    END PREFIX

END FASTPROC

' 

FASTPROC uc_cat

    PREFIX "! "

    mov edx, [esp+4]
    sub edx, 2
    mov ecx, [esp+8]
    xor eax, eax

  lbl0:
    add edx, 2
    cmp WORD PTR [edx], 0       ; find the end
    jne lbl0

  lbl1:
    mov ax, [ecx]               ; append 2nd string
    mov [edx], ax
    add ecx, 2
    add edx, 2
    test ax, ax
    jnz lbl1

    ret 8

    END PREFIX

END FASTPROC

' 

' ucMultiCat proc C pcount:DWORD,lpBuffer:DWORD,args:VARARG

FASTPROC uc_multicat

  ' --------------------------------------------------
  ' stack must be balanced by the caller
  ' 4 bytes for each PUSH * number of arguments
  ' ! add esp, 20   ; after call for 5 DWORD arguments
  ' --------------------------------------------------

    PREFIX "! "

    push esi
    push edi

    xor eax, eax                ; clear EAX for following partial reads and writes
    mov edi, [esp+8][8]         ; lpBuffer
    xor ecx, ecx                ; clear arg counter
    lea edx, [esp+12][8]        ; args
    sub edi, 2
  lbl0:
    add edi, 2
    mov ax, [edi]
    test ax, ax
    jne lbl0
  newstr:
    sub edi, 2
    mov esi, [edx+ecx*4]
  lbl1:
    add edi, 2
    mov ax, [esi]
    mov [edi], ax
    add esi, 2
    test ax, ax
    jne lbl1
    add ecx, 1
    cmp ecx, [esp+4][8]         ; pcount
    jne newstr

    mov eax, [esp+8][8]         ; lpBuffer

    pop edi
    pop esi

    ret                         ; stack must be corrected by caller

    END PREFIX

END FASTPROC

' 

FASTPROC uc_find

    PREFIX "! "

    push ebp
    mov ebp, esp                ; construct a stack frame
    add esp, &HFFFFFFF8         ; allocate LOCAL space

    push ebx
    push esi
    push edi

    xor edx, edx
    xor ebx, ebx
    mov edi, [ebp+16]
    mov bx, [edi]

    push DWORD PTR [ebp+12]
    call uc_len                 ; get the source length
    mov [ebp-4], eax

    mov eax, [ebp-4]
    add [ebp-4], eax            ; double for byte length

    push DWORD PTR [ebp+16]
    call uc_len                 ; get the pattern length
    mov [ebp-8], eax

    mov eax, [ebp-8]
    add eax, eax                ; double for byte length
    mov [ebp-8], eax
    sub DWORD PTR [ebp-8], 2
    sub [ebp-4], eax
    mov eax, [ebp+8]
    add [ebp+8], eax            ; double start pos to get BYTE location
    mov esi, [ebp+12]
    add esi, [ebp+8]
    add [ebp-4], esi
    sub esi, 2

  mainloop:
    add esi, 2
    cmp [esi], bx               ; test for start character
    jz presub
    cmp esi, [ebp-4]
    jle mainloop                ; fall through on no match
    jmp notfound

  presub:
    mov ecx, [ebp-8]

  sublp:
    mov dx, [ecx+esi]           ; do substring compare backwards
    cmp dx, [ecx+edi]
    jnz mainloop
    sub ecx, 2
    jz match                    ; fall through on match

    mov dx, [ecx+esi]           ; do substring compare backwards
    cmp dx, [ecx+edi]
    jnz mainloop
    sub ecx, 2
    jnz sublp                   ; fall through on match

  match:
    sub esi, [ebp+12]           ; calculated byte length
    mov eax, esi
    add eax, 2                  ; correct for 1 base index
    shr eax, 1                  ; divide by 2 to return character position
    jmp findout

  notfound:
    xor eax, eax                ; return zero on no match

  findout:
    pop edi
    pop esi
    pop ebx

    leave                       ; clean up stack frame
    ret 12                      ; balance stack and exit

    END PREFIX

END FASTPROC

' 




